Index: squid/src/asn.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/asn.c,v
retrieving revision 1.5.4.1
retrieving revision 1.5.4.2
diff -u -r1.5.4.1 -r1.5.4.2
--- squid/src/asn.c	14 Mar 2001 22:17:32 -0000	1.5.4.1
+++ squid/src/asn.c	19 Oct 2001 19:05:09 -0000	1.5.4.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: asn.c,v 1.5.4.1 2001/03/14 22:17:32 rbcollins Exp $
+ * $Id: asn.c,v 1.5.4.2 2001/10/19 19:05:09 serassio Exp $
  *
  * DEBUG: section 53    AS Number handling
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -408,7 +408,7 @@
 }
 
 static int
-mask_len(int mask)
+mask_len(u_long mask)
 {
     int len = 32;
     if (mask == 0)
Index: squid/src/authenticate.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/authenticate.c,v
retrieving revision 1.4.20.6
retrieving revision 1.4.20.7
diff -u -r1.4.20.6 -r1.4.20.7
--- squid/src/authenticate.c	30 Sep 2001 20:38:14 -0000	1.4.20.6
+++ squid/src/authenticate.c	19 Oct 2001 19:05:09 -0000	1.4.20.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: authenticate.c,v 1.4.20.6 2001/09/30 20:38:14 serassio Exp $
+ * $Id: authenticate.c,v 1.4.20.7 2001/10/19 19:05:09 serassio Exp $
  *
  * DEBUG: section 29    Authenticator
  * AUTHOR: Duane Wessels
@@ -934,7 +934,7 @@
 authSchemeAdd(char *type, AUTHSSETUP * setup)
 {
     int i;
-    debug(29, 4) ("authSchemeAdd: adding %s", type);
+    debug(29, 4) ("authSchemeAdd: adding %s\n", type);
     /* find the number of currently known authscheme types */
     for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) {
 	assert(strcmp(authscheme_list[i].typestr, type) != 0);
Index: squid/src/cache_cf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_cf.c,v
retrieving revision 1.6.10.12
retrieving revision 1.6.10.13
diff -u -r1.6.10.12 -r1.6.10.13
--- squid/src/cache_cf.c	25 Aug 2001 08:28:46 -0000	1.6.10.12
+++ squid/src/cache_cf.c	19 Oct 2001 19:05:09 -0000	1.6.10.13
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_cf.c,v 1.6.10.12 2001/08/25 08:28:46 serassio Exp $
+ * $Id: cache_cf.c,v 1.6.10.13 2001/10/19 19:05:09 serassio Exp $
  *
  * DEBUG: section 3     Configuration File Parsing
  * AUTHOR: Harvest Derived
@@ -563,20 +563,26 @@
 }
 
 static void
-dump_acl_access(StoreEntry * entry, const char *name, acl_access * head)
+dump_acl_list(StoreEntry * entry, acl_list * head)
 {
     acl_list *l;
-    while (head != NULL) {
+    for (l = head; l; l = l->next) {
+	storeAppendPrintf(entry, " %s%s",
+	    l->op ? null_string : "!",
+	    l->acl->name);
+    }
+}
+
+static void
+dump_acl_access(StoreEntry * entry, const char *name, acl_access * head)
+{
+    acl_access *l;
+    for (l = head; l; l = l->next) {
 	storeAppendPrintf(entry, "%s %s",
 	    name,
-	    head->allow ? "Allow" : "Deny");
-	for (l = head->acl_list; l != NULL; l = l->next) {
-	    storeAppendPrintf(entry, " %s%s",
-		l->op ? null_string : "!",
-		l->acl->name);
-	}
+	    l->allow ? "Allow" : "Deny");
+	dump_acl_list(entry, l->acl_list);
 	storeAppendPrintf(entry, "\n");
-	head = head->next;
     }
 }
 
@@ -620,6 +626,110 @@
     memset(addr, '\0', sizeof(struct in_addr));
 }
 
+CBDATA_TYPE(acl_address);
+
+static void
+dump_acl_address(StoreEntry * entry, const char *name, acl_address * head)
+{
+    acl_address *l;
+    for (l = head; l; l = l->next) {
+	if (l->addr.s_addr != INADDR_ANY)
+	    storeAppendPrintf(entry, "%s %s", name, inet_ntoa(l->addr));
+	else
+	    storeAppendPrintf(entry, "%s autoselect", name);
+	dump_acl_list(entry, l->acl_list);
+	storeAppendPrintf(entry, "\n");
+    }
+}
+
+static void
+freed_acl_address(void *data)
+{
+    acl_address *l = data;
+    aclDestroyAclList(&l->acl_list);
+}
+
+static void
+parse_acl_address(acl_address ** head)
+{
+    acl_address *l;
+    acl_address **tail = head;	/* sane name below */
+    CBDATA_INIT_TYPE_FREECB(acl_address, freed_acl_address);
+    l = cbdataAlloc(acl_address);
+    parse_address(&l->addr);
+    aclParseAclList(&l->acl_list);
+    while (*tail)
+	tail = &(*tail)->next;
+    *tail = l;
+}
+
+static void
+free_acl_address(acl_address ** head)
+{
+    while (*head) {
+	acl_address *l = *head;
+	*head = l->next;
+	cbdataFree(l);
+    }
+}
+
+CBDATA_TYPE(acl_tos);
+
+static void
+dump_acl_tos(StoreEntry * entry, const char *name, acl_tos * head)
+{
+    acl_tos *l;
+    for (l = head; l; l = l->next) {
+	if (l->tos > 0)
+	    storeAppendPrintf(entry, "%s 0x%02X", name, l->tos);
+	else
+	    storeAppendPrintf(entry, "%s none", name);
+	dump_acl_list(entry, l->acl_list);
+	storeAppendPrintf(entry, "\n");
+    }
+}
+
+static void
+freed_acl_tos(void *data)
+{
+    acl_tos *l = data;
+    aclDestroyAclList(&l->acl_list);
+}
+
+static void
+parse_acl_tos(acl_tos ** head)
+{
+    acl_tos *l;
+    acl_tos **tail = head;	/* sane name below */
+    int tos;
+    char junk;
+    char *token = strtok(NULL, w_space);
+    if (!token)
+	self_destruct();
+    if (sscanf(token, "0x%x%c", &tos, &junk) != 1)
+	self_destruct();
+    if (tos < 0 || tos > 255)
+	self_destruct();
+    CBDATA_INIT_TYPE_FREECB(acl_tos, freed_acl_tos);
+    l = cbdataAlloc(acl_tos);
+    l->tos = tos;
+    aclParseAclList(&l->acl_list);
+    while (*tail)
+	tail = &(*tail)->next;
+    *tail = l;
+}
+
+static void
+free_acl_tos(acl_tos ** head)
+{
+    while (*head) {
+	acl_tos *l = *head;
+	*head = l->next;
+	l->next = NULL;
+	cbdataFree(l);
+    }
+}
+
 #if DELAY_POOLS
 
 /* do nothing - free_delay_pool_count is the magic free function.
@@ -1809,7 +1919,7 @@
 void
 parse_eol(char *volatile *var)
 {
-    unsigned char *token = strtok(NULL, null_string);
+    unsigned char *token = (unsigned char *) strtok(NULL, null_string);
     safe_free(*var);
     if (token == NULL)
 	self_destruct();
@@ -1817,7 +1927,7 @@
 	token++;
     if (!*token)
 	self_destruct();
-    *var = xstrdup(token);
+    *var = xstrdup((char *) token);
 }
 
 static void
@@ -1908,8 +2018,8 @@
 }
 
 static void
-free_body_size_t(dlink_list * bodylist)		//acl_access ** head)
- {
+free_body_size_t(dlink_list * bodylist)
+{
     body_size *bs, *tempnode;
     bs = (body_size *) bodylist->head;
     while (bs) {
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.10.2.13
retrieving revision 1.10.2.14
diff -u -r1.10.2.13 -r1.10.2.14
--- squid/src/cf.data.pre	4 Oct 2001 19:50:28 -0000	1.10.2.13
+++ squid/src/cf.data.pre	19 Oct 2001 19:05:09 -0000	1.10.2.14
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.10.2.13 2001/10/04 19:50:28 serassio Exp $
+# $Id: cf.data.pre,v 1.10.2.14 2001/10/19 19:05:09 serassio Exp $
 #
 #
 # SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -94,7 +94,7 @@
 
         The socket address where Squid will listen for HTTPS client
         requests.
-	
+
         This is really only useful for situations where you are running
         squid in accelerator mode and you want to do the SSL work at the
         accelerator level.
@@ -173,12 +173,6 @@
 DOC_END
 
 
-NAME: tcp_outgoing_address outbound_address
-TYPE: address
-LOC: Config.Addrs.tcp_outgoing
-DEFAULT: 255.255.255.255
-DOC_NONE
-
 NAME: udp_incoming_address
 TYPE: address
 LOC:Config.Addrs.udp_incoming
@@ -193,8 +187,6 @@
 	Usage: tcp_incoming_address 10.20.30.40
 	       udp_outgoing_address fully.qualified.domain.name
 
-	tcp_outgoing_address	is used for connections made to remote
-				servers and other caches.
 	udp_incoming_address	is used for the ICP socket receiving packets
 				from other caches.
 	udp_outgoing_address	is used for ICP packets sent out to other
@@ -1574,25 +1566,32 @@
 DEFAULT: 95
 LOC: Config.quickAbort.pct
 DOC_START
-	The cache can be configured to continue downloading aborted
-	requests.  This may be undesirable on slow (e.g. SLIP) links
-	and/or very busy caches.  Impatient users may tie up file
-	descriptors and bandwidth by repeatedly requesting and
-	immediately aborting downloads.
+	The cache by default continues downloading aborted requests
+	which are almost completed (less than 16 KB remaining). This
+	may be undesirable on slow (e.g. SLIP) links and/or very busy
+	caches.  Impatient users may tie up file descriptors and
+	bandwidth by repeatedly requesting and immediately aborting
+	downloads.
 
 	When the user aborts a request, Squid will check the
 	quick_abort values to the amount of data transfered until
 	then.
 
 	If the transfer has less than 'quick_abort_min' KB remaining,
-	it will finish the retrieval.  Setting 'quick_abort_min' to -1
-	will disable the quick_abort feature.
+	it will finish the retrieval.
 
 	If the transfer has more than 'quick_abort_max' KB remaining,
 	it will abort the retrieval.
 
 	If more than 'quick_abort_pct' of the transfer has completed,
 	it will finish the retrieval.
+
+	If you do not want any retrieval to continue after the client
+	has aborted, set both 'quick_abort_min' and 'quick_abort_max'
+	to '0 KB'.
+
+	If you want retrievals to always continue if they are being
+	cached then set 'quick_abort_min' to '-1 KB'.
 DOC_END
 
 
@@ -2099,6 +2098,60 @@
 	the configure script.
 DOC_END
 
+NAME: tcp_outgoing_tos tcp_outgoing_ds tcp_outgoin_dscp
+TYPE: acl_tos
+DEFAULT: none
+LOC: Config.accessList.outgoing_tos
+DOC_START
+	Allows you to select a TOS/Diffserv value to mark outgoing
+	connections with, based on the username or source address
+	making the request.
+
+	tcp_outgoing_tos ds-field [!]aclname ...
+
+	Example where normal_service_net uses the TOS value 0x00
+	and normal_service_net uses 0x20
+
+	acl normal_service_net src 10.0.0.0/255.255.255.0
+	acl good_service_net src 10.0.1.0/255.255.255.0
+	tcp_outgoing_tos 0x00 normal_service_net 0x00
+	tcp_outgoing_tos 0x20 good_service_net
+
+	TOS/DSCP values really only have local significance - so you should
+	know what you're specifying. For more, see RFC 2474
+
+	The TOS/DSCP byte must be exactly that - a byte, value  0 - 255, or
+	"default" to use whatever default your host has.
+
+	Processing proceeds in the order specified, and stops at first fully
+	matching line.
+DOC_END
+
+NAME: tcp_outgoing_address
+TYPE: acl_address
+DEFAULT: none
+LOC: Config.accessList.outgoing_address
+DOC_START
+	Allows you to map requests to different outgoing IP addresses
+	based on the username or sourceaddress of the user making
+	the request.
+	
+	tcp_outgoing_address ipaddr [[!]aclname] ...
+
+	Example where requests from 10.0.0.0/24 will be forwareded
+	with source address 10.1.0.1, 10.0.2.0/24 forwarded with 
+	source address 10.1.0.2 and the rest will be forwarded with
+	source address 10.1.0.3.
+
+	acl normal_service_net src 10.0.0.0/255.255.255.0
+	acl good_service_net src 10.0.1.0/255.255.255.0
+	tcp_outgoing_address 10.0.0.1 normal_service_net
+	tcp_outgoing_address 10.0.0.2 good_service_net
+	tcp_outgoing_address 10.0.0.3
+
+	Processing proceeds in the order specified, and stops at first fully
+	matching line.
+DOC_END
 
 NAME: reply_body_max_size
 COMMENT: bytes allow|deny acl acl...
@@ -2402,6 +2455,10 @@
 	Appends local domain name to hostnames without any dots in
 	them.  append_domain must begin with a period.
 
+	Be warned that there today is Internet names with no dots in
+	them using only top-domain names, so setting this may
+	cause some Internet sites to become unavailable.
+
 Example:
  append_domain .yourdomain.com
 DOC_END
Index: squid/src/comm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm.c,v
retrieving revision 1.4.20.4
retrieving revision 1.4.20.5
diff -u -r1.4.20.4 -r1.4.20.5
--- squid/src/comm.c	27 Aug 2001 19:25:57 -0000	1.4.20.4
+++ squid/src/comm.c	19 Oct 2001 19:05:10 -0000	1.4.20.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm.c,v 1.4.20.4 2001/08/27 19:25:57 serassio Exp $
+ * $Id: comm.c,v 1.4.20.5 2001/10/19 19:05:10 serassio Exp $
  *
  * DEBUG: section 5     Socket Functions
  * AUTHOR: Harvest Derived
@@ -148,7 +148,7 @@
 }
 
 /* Create a socket. Default is blocking, stream (TCP) socket.  IO_TYPE
- * is OR of flags specified in comm.h. */
+ * is OR of flags specified in comm.h. Defaults TOS */
 int
 comm_open(int sock_type,
     int proto,
@@ -157,7 +157,23 @@
     int flags,
     const char *note)
 {
+    return comm_openex(sock_type, proto, addr, port, flags, 0, note);
+}
+
+
+/* Create a socket. Default is blocking, stream (TCP) socket.  IO_TYPE
+ * is OR of flags specified in defines.h:COMM_* */
+int
+comm_openex(int sock_type,
+    int proto,
+    struct in_addr addr,
+    u_short port,
+    int flags,
+    unsigned char TOS,
+    const char *note)
+{
     int new_socket;
+    int tos;
     fde *F = NULL;
 
     /* Create socket for accepting new connections. */
@@ -177,10 +193,23 @@
 	}
 	return -1;
     }
+    /* set TOS if needed */
+    if (TOS) {
+#ifdef IP_TOS
+	tos = TOS;
+	if (setsockopt(new_socket, IPPROTO_IP, IP_TOS, (char *) &tos, sizeof(int)) < 0)
+	        debug(50, 1) ("comm_open: setsockopt(IP_TOS) on FD %d: %s\n",
+		new_socket, xstrerror());
+#else
+	debug(50, 0) ("comm_open: setsockopt(IP_TOS) not supported on this platform\n");
+#endif
+    }
     /* update fdstat */
     debug(5, 5) ("comm_open: FD %d is a new socket\n", new_socket);
     fd_open(new_socket, FD_SOCKET, note);
     F = &fd_table[new_socket];
+    F->local_addr = addr;
+    F->tos = tos;
     if (!(flags & COMM_NOCLOEXEC))
 	commSetCloseOnExec(new_socket);
     if ((flags & COMM_REUSEADDR))
@@ -303,6 +332,7 @@
 commResetFD(ConnectStateData * cs)
 {
     int fd2;
+    fde *F;
     if (!cbdataValid(cs->data))
 	return 0;
     statCounter.syscalls.sock.sockets++;
@@ -318,23 +348,34 @@
 	debug(5, 0) ("commResetFD: dup2: %s\n", xstrerror());
 	if (ENFILE == errno || EMFILE == errno)
 	    fdAdjustReserved();
+	close(fd2);
 	return 0;
     }
     close(fd2);
+    F = &fd_table[cs->fd];
     fd_table[cs->fd].flags.called_connect = 0;
     /*
      * yuck, this has assumptions about comm_open() arguments for
      * the original socket
      */
-    commSetCloseOnExec(cs->fd);
-    if (Config.Addrs.tcp_outgoing.s_addr != no_addr.s_addr) {
-	if (commBind(cs->fd, Config.Addrs.tcp_outgoing, 0) != COMM_OK) {
-	    return 0;
-	}
+    if (commBind(cs->fd, F->local_addr, F->local_port) != COMM_OK) {
+	debug(5, 0) ("commResetFD: bind: %s\n", xstrerror());
+	return 0;
     }
-    commSetNonBlocking(cs->fd);
+#ifdef IP_TOS
+    if (F->tos) {
+	int tos = F->tos;
+	if (setsockopt(cs->fd, IPPROTO_IP, IP_TOS, (char *) &tos, sizeof(int)) < 0)
+	        debug(50, 1) ("commResetFD: setsockopt(IP_TOS) on FD %d: %s\n", cs->fd, xstrerror());
+    }
+#endif
+    if (F->flags.close_on_exec)
+	commSetCloseOnExec(cs->fd);
+    if (F->flags.nonblocking)
+	commSetNonBlocking(cs->fd);
 #ifdef TCP_NODELAY
-    commSetTcpNoDelay(cs->fd);
+    if (F->flags.nodelay)
+	commSetTcpNoDelay(cs->fd);
 #endif
     if (Config.tcpRcvBufsz > 0)
 	commSetTcpRcvbuf(cs->fd, Config.tcpRcvBufsz);
@@ -786,6 +827,7 @@
     }
     if (fcntl(fd, F_SETFD, flags | FD_CLOEXEC) < 0)
 	debug(50, 0) ("FD %d: set close-on-exec failed: %s\n", fd, xstrerror());
+    fd_table[fd].flags.close_on_exec = 1;
 #endif
 }
 
@@ -796,6 +838,7 @@
     int on = 1;
     if (setsockopt(fd, IPPROTO_TCP, TCP_NODELAY, (char *) &on, sizeof(on)) < 0)
 	debug(50, 1) ("commSetTcpNoDelay: FD %d: %s\n", fd, xstrerror());
+    fd_table[fd].flags.nodelay = 1;
 }
 #endif
 
Index: squid/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/defines.h,v
retrieving revision 1.3.22.14
retrieving revision 1.3.22.15
diff -u -r1.3.22.14 -r1.3.22.15
--- squid/src/defines.h	26 Aug 2001 09:02:01 -0000	1.3.22.14
+++ squid/src/defines.h	19 Oct 2001 19:05:10 -0000	1.3.22.15
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.3.22.14 2001/08/26 09:02:01 serassio Exp $
+ * $Id: defines.h,v 1.3.22.15 2001/10/19 19:05:10 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -31,6 +31,9 @@
  *
  */
 
+#ifndef SQUID_DEFINES_H
+#define SQUID_DEFINES_H
+
 #ifndef TRUE
 #define TRUE 1
 #endif
@@ -308,3 +311,5 @@
 #define _WIN_OS_WIN2K	6
 #define _WIN_OS_WINXP	7
 #endif
+
+#endif /* SQUID_DEFINES_H */
Index: squid/src/enums.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/enums.h,v
retrieving revision 1.6.10.5
retrieving revision 1.6.10.6
diff -u -r1.6.10.5 -r1.6.10.6
--- squid/src/enums.h	30 Sep 2001 20:38:14 -0000	1.6.10.5
+++ squid/src/enums.h	19 Oct 2001 19:05:10 -0000	1.6.10.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: enums.h,v 1.6.10.5 2001/09/30 20:38:14 serassio Exp $
+ * $Id: enums.h,v 1.6.10.6 2001/10/19 19:05:10 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -31,6 +31,9 @@
  *
  */
 
+#ifndef SQUID_ENUMS_H
+#define SQUID_ENUMS_H
+
 typedef enum {
     LOG_TAG_NONE,
     LOG_TCP_HIT,
@@ -138,7 +141,7 @@
     ACL_LOOKUP_NEEDED,
     ACL_LOOKUP_PENDING,
     ACL_LOOKUP_DONE,
-    ACL_PROXY_AUTH_NEEDED,
+    ACL_PROXY_AUTH_NEEDED
 } acl_lookup_state;
 
 enum {
@@ -510,7 +513,7 @@
     AUTH_ACL_CHALLENGE = -2,
     AUTH_ACL_HELPER = -1,
     AUTH_ACL_CANNOT_AUTHENTICATE = 0,
-    AUTH_AUTHENTICATED = 1,
+    AUTH_AUTHENTICATED = 1
 } auth_acl_t;
 
 typedef enum {
@@ -723,3 +726,5 @@
     VARY_OTHER,
     VARY_CANCEL
 };
+
+#endif /* SQUID_ENUMS_H */
Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.6.4.1
retrieving revision 1.6.4.2
diff -u -r1.6.4.1 -r1.6.4.2
--- squid/src/forward.c	14 Mar 2001 22:17:33 -0000	1.6.4.1
+++ squid/src/forward.c	19 Oct 2001 19:05:10 -0000	1.6.4.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.6.4.1 2001/03/14 22:17:33 rbcollins Exp $
+ * $Id: forward.c,v 1.6.4.2 2001/10/19 19:05:10 serassio Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -266,6 +266,58 @@
     comm_close(fd);
 }
 
+static struct in_addr
+aclMapAddr(acl_address * head, aclCheck_t * ch)
+{
+    acl_address *l;
+    struct in_addr addr;
+    for (l = head; l; l = l->next) {
+	if (aclMatchAclList(l->acl_list, ch))
+	    return l->addr;
+    }
+    addr.s_addr = INADDR_ANY;
+    return addr;
+}
+
+static int
+aclMapTOS(acl_tos * head, aclCheck_t * ch)
+{
+    acl_tos *l;
+    for (l = head; l; l = l->next) {
+	if (aclMatchAclList(l->acl_list, ch))
+	    return l->tos;
+    }
+    return 0;
+}
+
+struct in_addr
+getOutgoingAddr(request_t * request)
+{
+    aclCheck_t ch;
+    memset(&ch, '\0', sizeof(aclCheck_t));
+    if (request) {
+	ch.src_addr = request->client_addr;
+	ch.my_addr = request->my_addr;
+	ch.my_port = request->my_port;
+	ch.request = request;
+    }
+    return aclMapAddr(Config.accessList.outgoing_address, &ch);
+}
+
+unsigned long
+getOutgoingTOS(request_t * request)
+{
+    aclCheck_t ch;
+    memset(&ch, '\0', sizeof(aclCheck_t));
+    if (request) {
+	ch.src_addr = request->client_addr;
+	ch.my_addr = request->my_addr;
+	ch.my_port = request->my_port;
+	ch.request = request;
+    }
+    return aclMapTOS(Config.accessList.outgoing_tos, &ch);
+}
+
 static void
 fwdConnectStart(void *data)
 {
@@ -277,6 +329,8 @@
     const char *host;
     unsigned short port;
     time_t ctimeout;
+    struct in_addr outgoing;
+    unsigned short tos;
     assert(fs);
     assert(fwdState->server_fd == -1);
     debug(17, 3) ("fwdConnectStart: %s\n", url);
@@ -306,11 +360,17 @@
 #if URL_CHECKSUM_DEBUG
     assert(fwdState->entry->mem_obj->chksum == url_checksum(url));
 #endif
-    fd = comm_open(SOCK_STREAM,
+    outgoing = getOutgoingAddr(fwdState->request);
+    tos = getOutgoingTOS(fwdState->request);
+
+    debug(17, 3) ("fwdConnectStart: got addr %s, tos %d\n",
+	inet_ntoa(outgoing), tos);
+    fd = comm_openex(SOCK_STREAM,
 	0,
-	Config.Addrs.tcp_outgoing,
+	outgoing,
 	0,
 	COMM_NONBLOCKING,
+	tos,
 	url);
     if (fd < 0) {
 	debug(50, 4) ("fwdConnectStart: %s\n", xstrerror());
Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.5.16.3
retrieving revision 1.5.16.4
diff -u -r1.5.16.3 -r1.5.16.4
--- squid/src/ftp.c	30 Sep 2001 20:38:14 -0000	1.5.16.3
+++ squid/src/ftp.c	19 Oct 2001 19:05:10 -0000	1.5.16.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ftp.c,v 1.5.16.3 2001/09/30 20:38:14 serassio Exp $
+ * $Id: ftp.c,v 1.5.16.4 2001/10/19 19:05:10 serassio Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -1680,7 +1680,8 @@
     if (getsockname(ftpState->ctrl.fd, (struct sockaddr *) &addr, &addr_len)) {
 	debug(9, 0) ("ftpSendPasv: getsockname(%d,..): %s\n",
 	    ftpState->ctrl.fd, xstrerror());
-	addr.sin_addr = Config.Addrs.tcp_outgoing;
+	ftpFail(ftpState);
+	return;
     }
     /* Open data channel with the same local address as control channel */
     fd = comm_open(SOCK_STREAM,
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.5.12.13
retrieving revision 1.5.12.14
diff -u -r1.5.12.13 -r1.5.12.14
--- squid/src/globals.h	2 Sep 2001 08:46:08 -0000	1.5.12.13
+++ squid/src/globals.h	19 Oct 2001 19:05:10 -0000	1.5.12.14
@@ -1,6 +1,6 @@
 
 /*
- * $Id: globals.h,v 1.5.12.13 2001/09/02 08:46:08 serassio Exp $
+ * $Id: globals.h,v 1.5.12.14 2001/10/19 19:05:10 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -31,6 +31,9 @@
  *
  */
 
+#ifndef SQUID_GLOBALS_H
+#define SQUID_GLOBALS_H
+
 extern FILE *debug_log;		/* NULL */
 extern SquidConfig Config;
 extern SquidConfig2 Config2;
@@ -159,3 +162,5 @@
 extern unsigned int WIN32_OS_version;	/* 0 */
 extern char *WIN32_OS_string;
 #endif
+
+#endif /* SQUID_GLOBALS_H */
Index: squid/src/mk-globals-c.pl
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mk-globals-c.pl,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.72.1
diff -u -r1.1.1.1 -r1.1.1.1.72.1
--- squid/src/mk-globals-c.pl	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/src/mk-globals-c.pl	19 Oct 2001 19:05:10 -0000	1.1.1.1.72.1
@@ -1,6 +1,7 @@
 print "#include \"squid.h\"\n";
 while (<>) {
 	$init = undef;
+	next if (/ SQUID_GLOBALS_H/);
 	if (/^#/) {
 		print;
 		next;
Index: squid/src/neighbors.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/neighbors.c,v
retrieving revision 1.6.10.3
retrieving revision 1.6.10.4
diff -u -r1.6.10.3 -r1.6.10.4
--- squid/src/neighbors.c	29 Jun 2001 21:23:22 -0000	1.6.10.3
+++ squid/src/neighbors.c	19 Oct 2001 19:05:10 -0000	1.6.10.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: neighbors.c,v 1.6.10.3 2001/06/29 21:23:22 serassio Exp $
+ * $Id: neighbors.c,v 1.6.10.4 2001/10/19 19:05:10 serassio Exp $
  *
  * DEBUG: section 15    Neighbor Routines
  * AUTHOR: Harvest Derived
@@ -759,9 +759,9 @@
 
 /* ignoreMulticastReply
  * 
- * We want to ignore replies from multicast peers if the
- * cache_host_domain rules would normally prevent the peer
- * from being used
+ * * We want to ignore replies from multicast peers if the
+ * * cache_host_domain rules would normally prevent the peer
+ * * from being used
  */
 static int
 ignoreMulticastReply(peer * p, MemObject * mem)
@@ -1072,7 +1072,7 @@
 	return;			/* probe already running */
     if (squid_curtime - p->stats.last_connect_probe < Config.Timeout.connect)
 	return;			/* don't probe to often */
-    fd = comm_open(SOCK_STREAM, 0, Config.Addrs.tcp_outgoing,
+    fd = comm_open(SOCK_STREAM, 0, getOutgoingAddr(NULL),
 	0, COMM_NONBLOCKING, p->host);
     if (fd < 0)
 	return;
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.9.2.16
retrieving revision 1.9.2.17
diff -u -r1.9.2.16 -r1.9.2.17
--- squid/src/protos.h	30 Sep 2001 20:38:14 -0000	1.9.2.16
+++ squid/src/protos.h	19 Oct 2001 19:05:10 -0000	1.9.2.17
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.9.2.16 2001/09/30 20:38:14 serassio Exp $
+ * $Id: protos.h,v 1.9.2.17 2001/10/19 19:05:10 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -31,6 +31,9 @@
  *
  */
 
+#ifndef SQUID_PROTOS_H
+#define SQUID_PROTOS_H
+
 extern void accessLogLog(AccessLogEntry *);
 extern void accessLogRotate(void);
 extern void accessLogClose(void);
@@ -56,7 +59,9 @@
 extern int aclMatchAclList(const acl_list * list, aclCheck_t * checklist);
 extern void aclDestroyAccessList(struct _acl_access **list);
 extern void aclDestroyAcls(acl **);
+extern void aclDestroyAclList(acl_list **);
 extern void aclParseAccessLine(struct _acl_access **);
+extern void aclParseAclList(acl_list **);
 extern void aclParseAclLine(acl **);
 extern int aclIsProxyAuth(const char *name);
 extern err_type aclGetDenyInfoPage(acl_deny_info_list ** head, const char *name);
@@ -150,6 +155,7 @@
 extern void comm_init(void);
 extern int comm_listen(int sock);
 extern int comm_open(int, int, struct in_addr, u_short port, int, const char *note);
+extern int comm_openex(int, int, struct in_addr, u_short, int, unsigned char TOS, const char *);
 extern u_short comm_local_port(int fd);
 
 extern void commSetSelect(int, unsigned int, PF *, void *, time_t);
@@ -424,9 +430,9 @@
 /* field manipulation */
 extern int httpHeaderHas(const HttpHeader * hdr, http_hdr_type type);
 extern void httpHeaderPutInt(HttpHeader * hdr, http_hdr_type type, int number);
-extern void httpHeaderPutTime(HttpHeader * hdr, http_hdr_type type, time_t time);
+extern void httpHeaderPutTime(HttpHeader * hdr, http_hdr_type type, time_t htime);
 extern void httpHeaderPutStr(HttpHeader * hdr, http_hdr_type type, const char *str);
-extern void httpHeaderPutAuth(HttpHeader * hdr, const char *authScheme, const char *realm);
+extern void httpHeaderPutAuth(HttpHeader * hdr, const char *auth_scheme, const char *realm);
 extern void httpHeaderPutCc(HttpHeader * hdr, const HttpHdrCc * cc);
 extern void httpHeaderPutContRange(HttpHeader * hdr, const HttpHdrContRange * cr);
 extern void httpHeaderPutRange(HttpHeader * hdr, const HttpHdrRange * range);
@@ -440,7 +446,7 @@
 extern HttpHdrContRange *httpHeaderGetContRange(const HttpHeader * hdr);
 extern const char *httpHeaderGetStr(const HttpHeader * hdr, http_hdr_type id);
 extern const char *httpHeaderGetLastStr(const HttpHeader * hdr, http_hdr_type id);
-extern const char *httpHeaderGetAuth(const HttpHeader * hdr, http_hdr_type id, const char *authScheme);
+extern const char *httpHeaderGetAuth(const HttpHeader * hdr, http_hdr_type id, const char *auth_scheme);
 extern String httpHeaderGetList(const HttpHeader * hdr, http_hdr_type id);
 extern String httpHeaderGetStrOrList(const HttpHeader * hdr, http_hdr_type id);
 extern String httpHeaderGetByName(const HttpHeader * hdr, const char *name);
@@ -674,16 +680,14 @@
 extern void netdbInit(void);
 extern void netdbHandlePingReply(const struct sockaddr_in *from, int hops, int rtt);
 extern void netdbPingSite(const char *hostname);
-extern void netdbInit(void);
 extern void netdbDump(StoreEntry *);
 extern int netdbHops(struct in_addr);
 extern void netdbFreeMemory(void);
 extern int netdbHostHops(const char *host);
 extern int netdbHostRtt(const char *host);
-extern int netdbHostPeerRtt(const char *host, peer * peer);
+extern int netdbHostPeerRtt(const char *host, peer * p);
 extern void netdbUpdatePeer(request_t *, peer * e, int rtt, int hops);
 extern void netdbDeleteAddrNetwork(struct in_addr addr);
-extern int netdbHostPeerRtt(const char *host, peer * peer);
 extern void netdbBinaryExchange(StoreEntry *);
 extern EVH netdbExchangeStart;
 extern void netdbExchangeUpdatePeer(struct in_addr, peer *, double, double);
@@ -717,6 +721,8 @@
 extern void fwdLogRotate(void);
 extern void fwdStatus(FwdState *, http_status);
 #endif
+struct in_addr getOutgoingAddr(request_t * request);
+unsigned long getOutgoingTOS(request_t * request);
 
 extern void urnStart(request_t *, StoreEntry *);
 
@@ -784,7 +790,8 @@
 
 /* ident.c */
 #if USE_IDENT
-extern void identStart(struct sockaddr_in *me, struct sockaddr_in *peer, IDCB * callback, void *cbdata);
+extern void identStart(struct sockaddr_in *me, struct sockaddr_in *my_peer,
+    IDCB * callback, void *cbdata);
 extern void identInit(void);
 #endif
 
@@ -885,16 +892,13 @@
 extern void storeLockObject(StoreEntry *);
 extern void storeRelease(StoreEntry *);
 extern int storeUnlockObject(StoreEntry *);
-extern int storePendingNClients(const StoreEntry *);
 extern EVH storeMaintainSwapSpace;
 extern void storeExpireNow(StoreEntry *);
 extern void storeReleaseRequest(StoreEntry *);
-extern off_t storeLowestMemReaderOffset(const StoreEntry *);
 extern void storeConfigure(void);
 extern void storeNegativeCache(StoreEntry *);
 extern void storeFreeMemory(void);
 extern int expiresMoreThan(time_t, time_t);
-extern void InvokeHandlers(StoreEntry *);
 extern int storeEntryValidToSend(StoreEntry *);
 extern void storeTimestampsSet(StoreEntry *);
 extern void storeRegisterAbort(StoreEntry * e, STABH * cb, void *);
@@ -1020,7 +1024,7 @@
  */
 extern void storeRebuildStart(void);
 extern void storeRebuildComplete(struct _store_rebuild_data *);
-extern void storeRebuildProgress(int index, int total, int sofar);
+extern void storeRebuildProgress(int sd_index, int total, int sofar);
 
 /*
  * store_swapin.c
@@ -1315,3 +1319,5 @@
 extern int WIN32_Subsystem_Init(void);
 extern void WIN32_Exit(void);
 #endif
+
+#endif /* SQUID_PROTOS_H */
Index: squid/src/ssl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl.c,v
retrieving revision 1.3.22.3
retrieving revision 1.3.22.4
diff -u -r1.3.22.3 -r1.3.22.4
--- squid/src/ssl.c	17 Jul 2001 18:44:12 -0000	1.3.22.3
+++ squid/src/ssl.c	19 Oct 2001 19:05:10 -0000	1.3.22.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ssl.c,v 1.3.22.3 2001/07/17 18:44:12 serassio Exp $
+ * $Id: ssl.c,v 1.3.22.4 2001/10/19 19:05:10 serassio Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -468,11 +468,12 @@
     statCounter.server.all.requests++;
     statCounter.server.other.requests++;
     /* Create socket. */
-    sock = comm_open(SOCK_STREAM,
+    sock = comm_openex(SOCK_STREAM,
 	0,
-	Config.Addrs.tcp_outgoing,
+	getOutgoingAddr(request),
 	0,
 	COMM_NONBLOCKING,
+	getOutgoingTOS(request),
 	url);
     if (sock == COMM_ERROR) {
 	debug(26, 4) ("sslStart: Failed because we're out of sockets.\n");
Index: squid/src/ssl_support.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl_support.h,v
retrieving revision 1.1.30.2
retrieving revision 1.1.30.3
diff -u -r1.1.30.2 -r1.1.30.3
--- squid/src/ssl_support.h	6 May 2001 17:18:13 -0000	1.1.30.2
+++ squid/src/ssl_support.h	19 Oct 2001 19:05:10 -0000	1.1.30.3
@@ -32,8 +32,8 @@
  *
  */
 
-#ifndef SSL_SUPPORT_H
-#define SSL_SUPPORT_H
+#ifndef SQUID_SSL_SUPPORT_H
+#define SQUID_SSL_SUPPORT_H
 
 #include "config.h"
 #if HAVE_OPENSSL_SSL_H
@@ -47,4 +47,4 @@
 int ssl_read_method(int, char *, int);
 int ssl_write_method(int, const char *, int);
 
-#endif /* SSL_SUPPORT_H */
+#endif /* SQUID_SSL_SUPPORT_H */
